--[[ TODO
	
	Hook slash command for more accuracy on player
	vs server issues
	
	]]

-- ------------------------
-- GLOBAL VARIABLES
-- ------------------------

ChannelManager=CreateFrame("Frame", "ChannelManager", UIParent)

-- so we know when channels are loaded
ChannelManager_ChannelsLoaded = false

ChannelManager.TimeSinceLastUpdate = nil

-- -------------------------
-- ONLOAD FUNCTION
-- -------------------------

function ChannelManager_OnLoad()
	--p("Loading ChannelWatch")
	ChannelManager:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
	--ChannelManager:RegisterEvent("VARIABLES_LOADED")

	ChannelManager:SetScript("OnEvent", ChannelManager.OnEvent)
	ChannelManager:SetScript("OnUpdate", ChannelManager.OnUpdate)
	
	if not(customChannelName) then
		--p("loading default variables")
		customChannelName = { }
		
	--[[ begin debugging code
	else
		for i=5,10 do
			if customChannelName[i] then
				p("Channel number "..i.." had been loaded as: "..customChannelName[i])
			end
		end
	-- end debugging code]]	

	end

end

-- -------------------------
-- ONUPDATE FUNCTION
-- -------------------------

function ChannelManager:OnUpdate(elapsed)

	
	if ChannelManager.TimeSinceLastUpdate then
		ChannelManager.TimeSinceLastUpdate = ChannelManager.TimeSinceLastUpdate + elapsed
		
		if ChannelManager.TimeSinceLastUpdate > 3 then
			if ChannelManager_ChannelsLoaded then
				ChannelManager_SetChannels()
				ChannelManager.TimeSinceLastUpdate = nil
			else
				if ChannelManager_CheckChannels() then
					ChannelManager_ChannelsLoaded = true
				else
					ChannelManager_UpdateChannels()
				end
			
				ChannelManager.TimeSinceLastUpdate = 0
			end
			
		end
		
		
	end

end

-- -------------------------
-- ONEVENT FUNCTION
-- -------------------------
	
function ChannelManager:OnEvent(event, ...)

	if (event == "CHAT_MSG_CHANNEL_NOTICE") then
	
		ChannelManager.TimeSinceLastUpdate = 0
	
	end
	
	--[[
	
	if (event == "VARIABLES_LOADED") then
		
		if not(customChannelName) then
			--p("loading default variables")
			customChannelName = { }
		
		-- begin debugging code
		else
			for i=5,10 do
				if customChannelName[i] then
					p("Channel number "..i.." had been loaded as: "..customChannelName[i])
				end
			end
		-- end debugging code
			
		end
	
	end
	]]

end

-- -------------------------
-- CHANNELMANAGER FUNCTIONS
-- -------------------------

function ChannelManager_SetChannels()

	local tempChannelName = nil

	for i=5,10 do
	
		_, tempChannelName = GetChannelName(i)
		
		if tempChannelName then
			customChannelName[i] = tempChannelName
			--p("channel "..i.." set to: "..customChannelName[i])
		end
		
		if not(tempChannelName) then
			customChannelName[i] = nil
			--p("channel "..i.." set to nil")
		end
		
		tempChannelName = nil
		
	end
	
end

function ChannelManager_CheckChannels()

	--p("checking channels")

	local channelsAreCorrect = true
	local channelToStartAt = 5
	
	-- check the channels against our saved variables
	for i=5,10 do
		if customChannelName[i] then
			local _,tempChannelName = GetChannelName(i)
			
			--[[ debug code start
			if tempChannelName then
				p("channel "..i.." scanned as: "..tempChannelName)
			else
				p("channel "..i.." scanned and not found.")
			end
			-- debug code stop]]
				
			if not(tempChannelName) then
				channelsAreCorrect = false
			end
			
			tempChannelName = nil
		end
	end
	
	if channelsAreCorrect then
		ChannelManager.TimeSinceLastUpdate = nil
	end
	
	return channelsAreCorrect, channelToStartAt

end

function ChannelManager_UpdateChannels()

	local tempChannelName

	for i=5,10 do
		_, tempChannelName = GetChannelName(i)
		
		if customChannelName[i] and not(tempChannelName) then
			JoinChannelByName(customChannelName[i])
			ChatFrame_AddChannel(DEFAULT_CHAT_FRAME, customChannelName[i])
		end
	
	end

end

-- p FUNCTION
-- Print.  Handy for debugging.
function p(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, 1, .4, .4)
end